import time
import sys
from machine import I2C, Pin, PWM
from ssd1306 import SSD1306_I2C

scl = Pin(22)
sda = Pin(21)
freq = 100000

i2c = I2C(scl=scl,sda=sda,freq=freq)
oled = SSD1306_I2C(128,64,i2c)
oled.fill(0)

button_add = Pin( 17 , Pin.IN, Pin.PULL_UP )
button_right = Pin( 19 , Pin.IN , Pin.PULL_UP )
button_left = Pin( 18 , Pin.IN , Pin.PULL_UP )
button_run = Pin( 33 , Pin.IN , Pin.PULL_UP )

set_time = [0,0,0,0] #HR/MIN/SEC/SERVO
state = [0]

p4 = Pin(4)
servo = PWM(p4,freq=50)

def but_start(set_time):
    first = button_run.value()
    time.sleep(0.01)
    second = button_run.value()
    if first and not second:
        print('Button Push!')
    
    elif not first and second:
        but_run(set_time)

def but_run(set_time):
    while(1):     
        if(set_time[2] == 0 and set_time[1] == 0 and set_time[0] == 0):
            servo.duty(90) # Open Servo
            for i in range(set_time[3]):
                time.sleep(1) #Delay(1s)
                print(i)
            servo.duty(45) #Close Servo
            set_time[3] = 0
            sys.exit(1)
            
        elif(set_time[2] !=0 and set_time[1] == 0 and set_time[0] == 0):
            set_time[2] = set_time[2] - 1 #Sec - 1
            time.sleep(1) #delay(1s)
            
        elif(set_time[2] == 0 and set_time[1] != 0 and set_time[0] == 0):
            set_time[1] = set_time[1] - 1
            time.sleep(1)
            set_time[2] = 59
            time.sleep(1)
                
        elif(set_time[2] != 0 and set_time[1] != 0):    
            set_time[2] = set_time[2] - 1
            time.sleep(1)
            if(set_time[2] == 0 and set_time[1] != 0 ):
                set_time[1] = set_time[1] - 1
                set_time[2] = 59
                time.sleep(1)

        elif(set_time[2] == 0 and set_time[1] == 0 and set_time[0] != 0):
            set_time[0] = set_time[0] - 1
            time.sleep(1)
            set_time[1] = 59
            time.sleep(1)
                
        elif(set_time[2] == 0 and set_time[1] != 0 and set_time[0] != 0):
            set_time[1] = set_time[1] - 1
            set_time[2] = 59
            time.sleep(1)
        s0 = str(set_time[0])
        s1 = str(set_time[1])
        s2 = str(set_time[2])
        s3 = str(set_time[3])
        oled.text(s0,30-15,30)
        oled.text(":",46-15,30)
        oled.text(s1,54-15,30)
        oled.text(":",70-15,30)
        oled.text(s2,78-15,30)
        oled.text("|",100-15,30)
        oled.text(s3,105,30)
        oled.show()
        oled.fill(0)    
        print(set_time)
        print('Button released!')
    
def but(set_time, state):
    first = button_add.value()
    time.sleep(0.01)
    second = button_add.value()
    
    if(state[0] == 0):
        if first and not second:
            if(set_time[0] < 23):
                set_time[0] = set_time[0] + 1
                x = str(set_time[0])
                print(x)
                print(state[0])
                print(set_time[0])
                print(set_time)
                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])
                #oled.text(x,0,0)
                oled.text(x,30-15,30)
                oled.text(":",46-15,30)
                oled.text(s1,54-15,30)
                oled.text(":",70-15,30)
                oled.text(s2,78-15,30)
                oled.text("|",100-15,30)
                oled.text(s3,105,30)
                
            else :
                set_time[0] = 0
                x = str(set_time[0])
                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])
                oled.text(x,30-15,30)
                oled.text(":",46-15,30)
                oled.text(s1,54-15,30)
                oled.text(":",70-15,30)
                oled.text(s2,78-15,30)
                oled.text("|",100-15,30)
                oled.text(s3,105,30)
            
            oled.show()
            oled.fill(0)
            
        elif not first and second:
            print('Button released!')

    elif(state[0] == 1):
        if first and not second:            
            if(set_time[1] < 59):
                set_time[1] = set_time[1] + 1
                x = str(set_time[1])
    
                print(x)
                print(state[0])
                print(set_time[1])
                print(set_time)
                
                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])
                
                oled.text(s0,30-15,30)
                oled.text(":",46-15,30)
                oled.text(x,54-15,30)
                oled.text(":",70-15,30)
                oled.text(s2,78-15,30)
                oled.text("|",100-15,30)
                oled.text(s3,105,30)
                
            else :
                set_time[1] = 0
                x = str(set_time[1])
                
                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])
                
                oled.text(s0,30-15,30)
                oled.text(":",46-15,30)
                oled.text(x,54-15,30)
                oled.text(":",70-15,30)
                oled.text(s2,78-15,30)
                oled.text("|",100-15,30)
                oled.text(s3,105,30)

            oled.show()
            oled.fill(0)
            
        elif not first and second:
            print('Button released!')
            
    elif(state[0] == 2):
        if first and not second:
            if(set_time[2] < 59):
                set_time[2] = set_time[2] + 1
                x = str(set_time[2])
    
                print(x)
                print(state[0])
                print(set_time[2])
                print(set_time)
                
                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])
                
                oled.text(s0,30-15,30)
                oled.text(":",46-15,30)
                oled.text(s1,54-15,30)
                oled.text(":",70-15,30)
                oled.text(x,78-15,30)
                oled.text("|",100-15,30)
                oled.text(s3,105,30)
                
            else :
#                x = str(set_time[state[0]])
                set_time[2] = 0
                x = str(set_time[2])
#                set_time[state[0]] = 0

                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])

                oled.text(s0,30-15,30)
                oled.text(":",46-15,30)
                oled.text(s1,54-15,30)
                oled.text(":",70-15,30)
                oled.text(x,78-15,30)
                oled.text("|",100-15,30)
                oled.text(s3,105,30)

            oled.show()
            oled.fill(0)
            
        elif not first and second:
            print('Button released!')
    
    elif(state[0] == 3):
        if first and not second:
            if(set_time[3] < 59):
                set_time[3] = set_time[3] + 1
                x = str(set_time[3])
    
                print(x)
                print(state[0])
                print(set_time[3])
                print(set_time)

                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])

                oled.text(s0,30-15,30)
                oled.text(":",46-15,30)
                oled.text(s1,54-15,30)
                oled.text(":",70-15,30)
                oled.text(s2,78-15,30)
                oled.text("|",100-15,30)
                oled.text(x,105,30)
                
            else :
#                x = str(set_time[state[0]])
                set_time[3] = 0
                x = str(set_time[3])
#                set_time[state[0]] = 0

                s0 = str(set_time[0])
                s1 = str(set_time[1])
                s2 = str(set_time[2])
                s3 = str(set_time[3])

            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(x,105,30)

            oled.show()
            oled.fill(0)
            
        elif not first and second:
            print('Button released!')
    
def but_right(set_time, state):
    first = button_right.value()
    time.sleep(0.01)
    second = button_right.value()
    
    #   state[0] = state[0] + 1
        
    if(state[0] == 0):
        if first and not second:
            x = str(set_time[0])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,0,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)            
            oled.text("__",54-15,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 1
        
        elif not first and second:
            print('Button released!')
            
    elif(state[0] == 1):
        if first and not second:
            x = str(set_time[1])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,32,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)         
            oled.text("__",78-15,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 2

        elif not first and second:
            print('Button released!')
 
    elif(state[0] == 2):
        if first and not second:
            x = str(set_time[2])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,64,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)          
            oled.text("__",105,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 3

        elif not first and second:
            print('Button released!')
            
    elif(state[0] == 3):
        if first and not second:
            x = str(set_time[3])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,96,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)           
            oled.text("__",30-15,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 0
            
        elif not first and second:
            print('Button released!')
            
def but_left(set_time, state):
    
    first = button_left.value()
    time.sleep(0.01)
    second = button_left.value()
    
    #   state[0] = state[0] + 1
        
    if(state[0] == 0):
        if first and not second:
            x = str(set_time[0])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,0,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)           
            oled.text("__",105,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 3
        
        elif not first and second:
            print('Button released!')
            
    elif(state[0] == 1):
        if first and not second:
            x = str(set_time[1])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,32,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)         
            oled.text("__",15,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 0

        elif not first and second:
            print('Button released!')
 
    elif(state[0] == 2):
        if first and not second:
            x = str(set_time[2])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,64,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)          
            oled.text("__",54-15,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 1

        elif not first and second:
            print('Button released!')
            
    elif(state[0] == 3):
        if first and not second:
            x = str(set_time[3])
    #        set_time[state] = set_time[state[0]] + 1
    #        print(set_time[state[0]])
            print(state[0])
            #oled.text(x,96,0)
            
            s0 = str(set_time[0])
            s1 = str(set_time[1])
            s2 = str(set_time[2])
            s3 = str(set_time[3])
            
            oled.text(s0,30-15,30)
            oled.text(":",46-15,30)
            oled.text(s1,54-15,30)
            oled.text(":",70-15,30)
            oled.text(s2,78-15,30)
            oled.text("|",100-15,30)
            oled.text(s3,105,30)          
            oled.text("__",78-15,32)
            oled.show()
            oled.fill(0)
            print(set_time)
            state[0] = 2
            
        elif not first and second:
            print('Button released!')

def display(set_time):
    but_right(set_time, state)
    but_left(set_time, state)
    but(set_time, state)
    but_start(set_time)

s0 = str(set_time[0])
s1 = str(set_time[1])
s2 = str(set_time[2])
s3 = str(set_time[3])
            
oled.text(s0,30-15,30)
oled.text(":",46-15,30)
oled.text(s1,54-15,30)
oled.text(":",70-15,30)
oled.text(s2,78-15,30)
oled.text("|",100-15,30)
oled.text(s3,105,30)

oled.show()
oled.fill(0)

while(1):
    display(set_time)
