import time 
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C

scl = Pin(22)
sda = Pin(21)
freq = 100000

i2c = I2C(scl=scl,sda=sda,freq=freq)
button = Pin( 19 , Pin.IN , Pin.PULL_UP )

set_time = [00,00,00,00]

oled = SSD1306_I2C(128,64,i2c)
oled.fill(0)    

def heart(a,b,s):
    ICON = [
        [ 0, 0, 0, 0, 0, 0, 0, 0, 0],
        [ 0, 1, 1, 0, 0, 0, 1, 1, 0],
        [ 1, 1, 1, 1, 0, 1, 1, 1, 1],
        [ 1, 1, 1, 1, 1, 1, 1, 1, 1],
        [ 1, 1, 1, 1, 1, 1, 1, 1, 1],
        [ 0, 1, 1, 1, 1, 1, 1, 1, 0],
        [ 0, 0, 1, 1, 1, 1, 1, 0, 0],
        [ 0, 0, 0, 1, 1, 1, 0, 0, 0],
        [ 0, 0, 0, 0, 1, 0, 0, 0, 0],
        ]

    #display.fill(0) # Clear the display
    for y, row in enumerate(ICON):
        for x, c in enumerate(row):
            oled.pixel(x + a , y + b , c)
            oled.pixel(x + a + s, y + b , c)

    return oled.show()    

def clock(a,b,s):
    ICON = [
        [ 0, 0, 1, 1, 1, 1, 1, 0, 0],
        [ 0, 1, 0, 0, 1, 0, 0, 1, 0],
        [ 1, 0, 0, 0, 1, 0, 0, 0, 1],
        [ 1, 0, 0, 0, 1, 0, 0, 0, 1],
        [ 1, 0, 0, 0, 1, 1, 1, 0, 1],
        [ 1, 0, 0, 0, 0, 0, 0, 0, 1],
        [ 1, 0, 0, 0, 0, 0, 0, 0, 1],
        [ 0, 1, 0, 0, 0, 0, 0, 1, 0],
        [ 0, 0, 1, 1, 1, 1, 1, 0, 0],
        ]
    for y, row in enumerate(ICON):
        for x, c in enumerate(row):
            oled.pixel(x + a , y + b , c)
            oled.pixel(x + a + s, y + b, c)
            
    return oled.show()

def real_time():
    second = time.time()
    sec = second + 637903800 + 721000
    times = time.localtime(sec)
    
    y = times[0] + 0
    year = str(y)
    
    m = times[1] + 0
    month = str(m)
    
    d = times[2] + 0
    day = str(d)
    
    h = times[3] + 0
    hr = str(h)
    
    mi = times[4] + 0
    minute = str(mi)
    
    s = times[5] + 0  
    sec = str(s)
    
    oled.text(year, 21 , 20)
    oled.text("/", 57 , 20)
    oled.text(month, 68  ,20)
    oled.text("/", 85 , 20)
    oled.text(day, 95 , 20)
    
    oled.text(hr, 26 , 40)
    oled.text(":", 44 , 40)
    oled.text(minute, 56 ,40)
    
    oled.text(":", 74 , 40)
    oled.text(sec, 86 , 40)
    
    #print(times)
    oled.show()
    
    heart(0,18,118)
    clock(0,38,118)
    
    #time.sleep(1)
    oled.fill(0) # clear display

while(1):
    real_time()



