import machine, onewire, ds18x20, time
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C

ds_pin = machine.Pin(4)
ds_sensor = ds18x20.DS18X20(onewire.OneWire(ds_pin))

roms = ds_sensor.scan()
print('Found DS devices: ', roms)

i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)
oled = SSD1306_I2C(128,64,i2c)
oled.fill(0)
oled.text("Temperature", 30, 20);

while True:
  ds_sensor.convert_temp()
  time.sleep_ms(750)
  for rom in roms:
    #print(rom)
    T = ds_sensor.read_temp(rom)
    print(ds_sensor.read_temp(rom))
    oled.text(str(T), 30, 40);
    oled.show()
    oled.fill(0)
    oled.text("Temperature", 30, 20);
    
  time.sleep(5)